using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace DropDownRows
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(48, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(384, 360);
			this.gridGroupingControl1.TabIndex = 1;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 422);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 50;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(100).ToString();
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;
			this.gridGroupingControl1.ShowGroupDropArea = true;

			Syncfusion.Grouping.SortColumnDescriptor cd = new Syncfusion.Grouping.SortColumnDescriptor("Col2");
			cd.Categorizer = new CustomCategorizer();
			cd.Comparer = new CustomComparer();
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add(cd);
		}
	}


	//takes teh custom grouping into account
	public class CustomComparer : IComparer
	{
		#region IComparer Members

		public int Compare(object x, object y)
		{
			if(x == null)
				return -1;
			else if(y == null)
				return 100;
			else 
			{
				int i = int.Parse(x.ToString());
				int j = int.Parse(y.ToString());
				int ret = GetCategory(i) - GetCategory(j);
				if(ret == 0)
					return i - j;
				else 
					return ret;
			}
		}

		#endregion

		//defines a group and returns a group id object (here returne 1 through 5)
		public static int GetCategory(int i)
		{
			int ret = 0;
			if(i < 10)
				ret = 1;
			else if(i >= 10 && i < 20)
				ret = 2;
			else if(i >= 20 && i < 30)
				ret = 3;
			else if(i >= 30 && i < 40)
				ret = 4;
			else  
				ret = 5;
				 
			return ret;
		}

	}


	public class CustomCategorizer : Syncfusion.Grouping.IGroupByColumnCategorizer
	{
		#region IGroupByColumnCategorizer Members

		public object GetGroupByCategoryKey(SortColumnDescriptor column, bool isForeignKey, Record record)
		{
			return CustomComparer.GetCategory(int.Parse( record.GetValue(column).ToString()));
		}

		public int CompareCategoryKey(SortColumnDescriptor column, bool isForeignKey, object category, Record record)
		{
				return CustomComparer.GetCategory( int.Parse(record.GetValue(column).ToString())) - (int)category;
		}

		#endregion

	}

	
}
